#include <hsm/interaction/Protocol.h>

struct RaiseLower : virtual hsm::Protocol {
	virtual void raise() {}
	virtual void lower() {}
};

struct Deletable : virtual hsm::Protocol {
protected :
	int nUse;
	
public :
	Deletable() : nUse(0) {}
	
	virtual bool begin() {
		nUse++;
		return true;
	}
	
	virtual void end() {
		nUse--;
	}

	virtual void remove() {
		if(nUse == 0) {
			delete this;
		}
	}
};

struct Colorable : virtual hsm::Protocol {
	virtual void setColor(float r, float g, float b) {}
};