////////////////////////////////////////////////////////////////////////////////
// File    : Chrono.cpp
// Content :
// History : 19-Mar-2003 - [rb] creation
////////////////////////////////////////////////////////////////////////////////

/*
    Copyright (C) 2004  Renaud Blanch <rb.hsm@laposte.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/* includes *******************************************************************/

#include <Chrono.h>

#include <hsm/system/time/Time.h>


namespace hsm {

/* Chrono class definition ****************************************************/

	void Chrono::start() {
		s = time::get();
	}
	
	float Chrono::stop() {
		n = time::get();
		d = (n - s) / 1000.0;
		return d;
	}
	
	Chrono::operator const float() const {
		return d;
	}

} // namespace hsm