////////////////////////////////////////////////////////////////////////////////
// File    : Chrono.h
// Content : a basic class to get time elapsed
// History : 19-Mar-2003 - [rb] creation
////////////////////////////////////////////////////////////////////////////////

/*
    Copyright (C) 2004  Renaud Blanch <rb.hsm@laposte.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/// \file Chrono.h
/// A simple chronometer class.


#if !defined(HSM_CHRONO_H)
#define HSM_CHRONO_H


namespace hsm {

/* Chrono class declaration ***************************************************/

	/// Implements a chronometer.
	class Chrono {
	private :
		long s;
		long n;
		float d;
   
	public :
		/// starts the chronometer (and reset it)
		void start();

		/// stops the chronometer
		/// \return the time elapsed between the last start and now in millisec.
		float stop();
		
		/// casts a Chrono instance to float
		/// \return the time between last start and last stop.
		operator const float() const;
	};


} // namespace Inputlibrary


#endif // !defined(HSM_CHRONO_H)