////////////////////////////////////////////////////////////////////////////////
// File    : Debug.cpp
// Content : usefull macros
// History : 09-Aou-2001 - [rb] creation
////////////////////////////////////////////////////////////////////////////////

/*
    Copyright (C) 2003  Renaud Blanch <rb.hsm@laposte.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/* includes *******************************************************************/

#include <Debug.h>

#include <string>
#include <sstream>


namespace hsm {

	namespace debug {

/* debug level ****************************************************************/

		unsigned int debugLevel = 0;

		unsigned int getLevel() {
			return debugLevel;
		}

		void setLevel(unsigned int d) {
			debugLevel = d;
			HSM_PRINT(0, "debugLevel set to " << d)
		}


	} // namespace debug

} // namespace hsm


HSM_DEBUG(

namespace hsm {

	namespace debug {

/* loading action *************************************************************/

		namespace {
		
			class Loader {
			private :
				static const Loader instance;
				
			private :
				Loader() {
					unsigned int dlc = getLevel();
					unsigned int dl = 0;
					char *cdl = getenv("HSM_DEBUG_LEVEL");
					if(cdl != 0) {
						std::string sdl = cdl;
						std::stringstream strdl; strdl << sdl;
						strdl >> dl;
					}
					if(dl > dlc) {
						setLevel(dl);
					}
				}
			};

			const Loader Loader::instance;

		} // namespace
		
	} // namespace debug

} // namespace hsm

) // HSM_DEBUG
